РГР/config/routes.rb
Rails.application.routes.draw do
  root 'labs#index'

  resources :labs

  get '/labs/:id/mark', to: 'labs#mark', as: 'mark_lab'

  post '/labs/:id/mark', to: 'labs#grade'
end

РГР/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

РГР/app/models/lab.rb
class Lab < ApplicationRecord
  belongs_to :user

  validates :title, presence: true, length: { maximum: 250 }
  validates :description, length: { maximum: 250 }
end

РГР/app/models/user.rb
class User < ApplicationRecord
  has_many :labs

  validates :first_name, presence: true, length: { maximum: 100 }
  validates :last_name, presence: true, length: { maximum: 100 }
  validates_format_of :email, with: URI::MailTo::EMAIL_REGEXP
end

РГР/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  include ErrorHandling
end

РГР/app/controllers/concerns/error_handling.rb
module ErrorHandling
  extend ActiveSupport::Concern

  included do
    rescue_from ActiveRecord::RecordNotFound, with: :notfound

    private

    def notfound
      render file: 'public/404.html', status: :not_found, layout: false
    end
  end
end

РГР/app/controllers/labs_controller.rb
class LabsController < ApplicationController
  before_action :find_lab, only: %i[show update destroy edit mark grade]

  def index
    @labs = Lab.all
  end

  def show
  end

  def new
    @lab = Lab.new
  end

  def create
    @lab = Lab.new(lab_params)
    @lab.user_id = 1

    if @lab.save
      redirect_to root_url
      flash[:success] = "Лабораторная успешно создана"
    else
      render 'new'
    end
  end

  def edit
  end

  def update
    if (@lab.update(lab_params))
      redirect_to root_url
      flash[:success] = "Лабораторная успешно обновлена"
    else
      render 'edit'
    end
  end

  def mark
  end

  def grade
    if (@lab.update(params.permit(:grade)))
      redirect_to root_url
      flash[:success] = "Лабораторная успешно оценена"
    else
      render 'mark'
    end
  end

  def destroy
    @lab.destroy

    redirect_to action: :index
    flash[:success] = "Лабораторная успешно удалена"
  end

  private

  def find_lab
    @lab = Lab.find params[:id]
  end

  def lab_params
    params.require(:lab).permit(:title, :description)
  end
end

РГР/app/helpers/application_helper.rb
module ApplicationHelper
end

РГР/app/views/labs/_form.html.erb
<%= form_with model: @lab do |f|%>
  <% if @lab.errors.any?%>
    <% @lab.errors.full_messages.each do |msg|%>
    <div class="alert alert-danger"><%= msg %></div>
    <% end %>
  <% end %>

  <h4>Название</h4>
    <%= f.text_field :title, required: true%><br>

  <h4>Описание</h4>
    <%= f.text_area :description, {:class => 'form-control'}%><br>

    <%= f.submit "Сохранить", ({:class => 'btn btn-success'}) %>
    <button type="button" class="btn btn-secondary"><%= link_to "Назад", root_path%></button>
<% end %>

РГР/app/views/labs/edit.html.erb
<h2 style="text-align: center"><b>Редактирование лабораторной работы</b></h2><br>

<%= render 'form' %>

РГР/app/views/labs/index.html.erb
<h1 style="text-align: center"><b>Учёт лабораторных работ</b></h1><br>

<button type="button" class="btn btn-outline-primary"><%= link_to "Добавить лабораторную работу", new_lab_path%></button><br><br>

<% flash.each do |type, msg| %>
  <div class="alert alert-<%= type %>">
    <%= msg %>
  </div>
<% end %>

<table class="table">
  <thead>
    <th scope="col">Название</th>
    <th scope="col">Описание</th>
    <th scope="col">Оценка</th>
  </thead>

  <tbody>
    <% @labs.each do |lab| %>
      <tr>
        <td><%= lab.title %></td>
        <td><%= lab.description %></td>
        <td><%= lab.grade %></td>
        <td><button type="button" class="btn btn-outline-primary"><%= link_to "Изменить", edit_lab_path(lab) %></button></td>
        <td><button type="button" class="btn btn-outline-warning"><%= link_to "Оценить", mark_lab_path(lab) %></button></td>
        <td><button type="button" class="btn btn-outline-danger"><%= link_to "Удалить", lab_path(lab), method: :delete, data: {confirm: "Вы уверены?"} %></button></td>
      </tr>
    <% end %>
  </tbody>
</table>

РГР/app/views/labs/mark.html.erb
<h2 style="text-align: center"><b>Выставление оценки</b></h2><br>

<%= form_with url: mark_lab_path(@lab) do |f| %>
  <% if @lab.errors.any?%>
    <% @lab.errors.full_messages.each do |msg| %>
    <div class="alert alert-danger"><%= msg %></div>
    <% end %>
  <% end %>

  <h4>Оценка (A, B, C, D, E, FX, F)</h4>
    <%= f.text_field :grade, {:class => 'form-control'} %><br>

    <%= f.submit "Сохранить",({:class => 'btn btn-success'}) %>
    <button type="button" class="btn btn-secondary"><%= link_to "Назад", root_path %></button>
<% end %>

РГР/app/views/labs/new.html.erb
<h2 style="text-align: center"><b>Добавление лабораторной работы</b></h2><br>

<%= render 'form' %>

РГР/app/views/labs/show.html.erb
<h1>Название: <%= @lab.title %></h1><br>
<h2>Описание: <%= @lab.description %></h2><br>
<h2>Оценка: <%= @lab.grade %></h2><br>
<button type="button" class="btn btn-primary"><%= link_to "Изменить", edit_lab_path(@lab) %></button>
<button type="button" class="btn btn-secondary"><%= link_to "Назад", labs_path %></button>
<button type="button" class="btn btn-warning"><%= link_to "Оценить", mark_lab_path %></button>

РГР/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Учёт лабораторных работ</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>

    <style>
      a {
       text-decoration: none;
       color: black
      }
   </style>
  </head>

  <body>
    <div class="container">
      <%= yield %>
    </div>
  </body>
</html>